Index: src/main/java/com/xpn/xwiki/store/XWikiHibernateStore.java
===================================================================
--- src/main/java/com/xpn/xwiki/store/XWikiHibernateStore.java	(revision 3976)
+++ src/main/java/com/xpn/xwiki/store/XWikiHibernateStore.java	(working copy)
@@ -22,6 +22,7 @@
 import com.xpn.xwiki.XWiki;
 import com.xpn.xwiki.XWikiContext;
 import com.xpn.xwiki.XWikiException;
+import com.xpn.xwiki.api.DocumentAction;
 import com.xpn.xwiki.doc.XWikiAttachment;
 import com.xpn.xwiki.doc.XWikiDocument;
 import com.xpn.xwiki.doc.XWikiLink;
@@ -1798,7 +1799,7 @@
 
                 XWikiDocument doc = new XWikiDocument((String)result[0], (String)result[1]);
                 if (checkRight) {
-                    if (context.getWiki().getRightService().checkAccess("view", doc, context)==false)
+                    if (context.getWiki().getRightService().checkAccess(DocumentAction.VIEW, doc, context)==false)
                         continue;
                 }
 
Index: src/main/java/com/xpn/xwiki/XWikiInterface.java
===================================================================
--- src/main/java/com/xpn/xwiki/XWikiInterface.java	(revision 3976)
+++ src/main/java/com/xpn/xwiki/XWikiInterface.java	(working copy)
@@ -21,6 +21,7 @@
 
 package com.xpn.xwiki;
 
+import com.xpn.xwiki.api.DocumentAction;
 import com.xpn.xwiki.api.User;
 import com.xpn.xwiki.doc.XWikiDocument;
 import com.xpn.xwiki.notify.XWikiNotificationManager;
@@ -211,8 +212,15 @@
 
     XWikiUser checkAuth(XWikiContext context) throws XWikiException;
 
+    /**
+     * @deprecated use
+     *             {@link XWikiInterface#checkAccess(DocumentAction, XWikiDocument, XWikiContext)}
+     */
     boolean checkAccess(String action, XWikiDocument doc, XWikiContext context)
             throws XWikiException;
+    
+    boolean checkAccess(DocumentAction action, XWikiDocument doc, XWikiContext context)
+            throws XWikiException;
 
     String include(String topic, XWikiContext context, boolean isForm) throws XWikiException;
 
@@ -246,11 +254,24 @@
     String getEncoding();
 
     URL getServerURL(String database, XWikiContext context) throws MalformedURLException;
-
+    
+    /**
+     * @deprecated use {@link XWikiInterface#getURL(String, DocumentAction, XWikiContext)}
+     */
     String getURL(String fullname, String action, XWikiContext context) throws XWikiException;
 
-    String getURL(String fullname, String action, String querystring, XWikiContext context) throws XWikiException;
+    String getURL(String fullname, DocumentAction action, XWikiContext context)
+        throws XWikiException;
 
+    /**
+     * @deprecated use {@link XWikiInterface#getURL(String, DocumentAction, String, XWikiContext)}
+     */
+    String getURL(String fullname, String action, String querystring, XWikiContext context)
+        throws XWikiException;
+
+    String getURL(String fullname, DocumentAction action, String querystring, XWikiContext context)
+        throws XWikiException;
+
     // Usefull date functions
     Date getCurrentDate();
 
Index: src/main/java/com/xpn/xwiki/stats/impl/DocumentStats.java
===================================================================
--- src/main/java/com/xpn/xwiki/stats/impl/DocumentStats.java	(revision 3976)
+++ src/main/java/com/xpn/xwiki/stats/impl/DocumentStats.java	(working copy)
@@ -22,12 +22,18 @@
 package com.xpn.xwiki.stats.impl;
 
 import java.util.Date;
+
+import com.xpn.xwiki.api.DocumentAction;
 
 public class DocumentStats extends XWikiStats {
 
     public DocumentStats() {
     }
-
+
+    /**
+     * @see DocumentStats#DocumentStats(String, DocumentAction, Date, int)
+     * @deprecated use {@link DocumentStats#DocumentStats(String, DocumentAction, Date, int)} 
+     */
     public DocumentStats(String docName, String action, Date period, int periodtype) {
         super(period, periodtype);
         setName(docName);
@@ -35,7 +41,16 @@
         String nb = action + getPeriod();
         setNumber(nb.hashCode());
         setAction(action);
-    }
+    }
+    
+    public DocumentStats(String docName, DocumentAction action, Date period, int periodtype) {
+        super(period, periodtype);
+        setName(docName);
+        setClassName("internal");
+        String nb = action.toString() + getPeriod();
+        setNumber(nb.hashCode());
+        setAction(action.toString());
+    }    
 
     public String getAction() {
         return getStringValue("action");
Index: src/main/java/com/xpn/xwiki/stats/impl/XWikiStatsServiceImpl.java
===================================================================
--- src/main/java/com/xpn/xwiki/stats/impl/XWikiStatsServiceImpl.java	(revision 3976)
+++ src/main/java/com/xpn/xwiki/stats/impl/XWikiStatsServiceImpl.java	(working copy)
@@ -23,6 +23,7 @@
 
 import com.xpn.xwiki.XWikiContext;
 import com.xpn.xwiki.XWikiException;
+import com.xpn.xwiki.api.DocumentAction;
 import com.xpn.xwiki.doc.XWikiDocument;
 import com.xpn.xwiki.notify.XWikiActionRule;
 import com.xpn.xwiki.notify.XWikiNotificationRule;
@@ -76,15 +77,33 @@
     }
 
     /**
+     * @see XWikiStatsServiceImpl#getDocTotalStats(String, DocumentAction, XWikiContext)
+     * @deprecated use {@link XWikiStatsServiceImpl#getDocTotalStats(String, DocumentAction, XWikiContext)}
+     */
+    public DocumentStats getDocTotalStats(String docname, String action, XWikiContext context) {
+        DocumentAction documentAction = DocumentAction.valueOf(action);
+        return this.getDocTotalStats(docname, documentAction, context);
+    }
+    
+    /**
      * Gets total statistics on a document for a specific action
      *
      * @param docname fully qualified document named
      * @param action can be "view", "edit", "save", etc..
      * @param context
      * @return DocStats - statistics object
+     */    
+    public DocumentStats getDocTotalStats(String docname, DocumentAction action, XWikiContext context) {
+        return new DocumentStats();
+    }    
+
+    /**
+     * @see XWikiStatsServiceImpl#getDocMonthStats(String, DocumentAction, Date, XWikiContext)
+     * @deprecated use {@link XWikiStatsServiceImpl#getDocMonthStats(String, DocumentAction, Date, XWikiContext)}
      */
-    public DocumentStats getDocTotalStats(String docname, String action, XWikiContext context) {
-        return new DocumentStats();
+    public DocumentStats getDocMonthStats(String docname, String action, Date month, XWikiContext context) {
+        DocumentAction documentAction = DocumentAction.valueOf(action);
+        return this.getDocMonthStats(docname, documentAction, month, context);
     }
 
     /**
@@ -95,7 +114,7 @@
      * @param context
      * @return
      */
-    public DocumentStats getDocMonthStats(String docname, String action, Date month, XWikiContext context) {
+    public DocumentStats getDocMonthStats(String docname, DocumentAction action, Date month, XWikiContext context) {
         XWikiHibernateStore store = context.getWiki().getHibernateStore();
         DocumentStats object = new DocumentStats(docname, action, month, XWikiStats.PERIOD_MONTH);
         try {
@@ -104,20 +123,29 @@
         } catch (XWikiException e) {
             e.printStackTrace();
             return new DocumentStats();
-        }
+        }        
     }
 
     /**
+     * @see XWikiStatsServiceImpl#getDocDayStats(String, DocumentAction, Date, XWikiContext)
+     * @deprecated use {@link XWikiStatsServiceImpl#getDocDayStats(String, DocumentAction, Date, XWikiContext)} 
+     */
+    public DocumentStats getDocDayStats(String docname, String action, Date day, XWikiContext context) {
+        DocumentAction documentAction = DocumentAction.valueOf(action);
+        return this.getDocDayStats(docname, documentAction, day, context);
+    }
+    
+    /**
      * Gets daily statistics on a document for a specific action
      * @param docname
      * @param action
      * @param day
      * @param context
      * @return
-     */
-    public DocumentStats getDocDayStats(String docname, String action, Date day, XWikiContext context) {
+     */    
+    public DocumentStats getDocDayStats(String docname, DocumentAction action, Date day, XWikiContext context) {
         return new DocumentStats();
-    }
+    }    
 
     public List getRefMonthStats(String docname, Date month, XWikiContext context) throws XWikiException {
     	XWikiStoreInterface store = context.getWiki().getNotCacheStore();
@@ -129,12 +157,20 @@
     	}
         return solist;
     }
+    
+    /**
+     * @deprecated use {@link XWikiStatsServiceImpl#getRecentActions(DocumentAction, int, XWikiContext)}
+     */
+    public Collection getRecentActions(String action, int size, XWikiContext context) {
+        DocumentAction documentAction = DocumentAction.valueOf(action);
+        return this.getRecentActions(documentAction, size, context);
+    }
 
-    public Collection getRecentActions(String action, int size, XWikiContext context) {
+    public Collection getRecentActions(DocumentAction action, int size, XWikiContext context) {
         ArrayList list = new ArrayList();
-        if ((action.equals("view")||(action.equals("save")))) {
+        if ((action.equals(DocumentAction.VIEW)||(action.equals(DocumentAction.SAVE)))) {
             HttpSession session = context.getRequest().getSession();
-            Collection actions = (Collection) session.getAttribute("recent_" + action);
+            Collection actions = (Collection) session.getAttribute("recent_" + action.toString());
 
             if (actions!=null) {
                Object[] actionsarray = actions.toArray();
@@ -154,24 +190,25 @@
      * @param action
      * @param context
      */
-    public void notify(XWikiNotificationRule rule, XWikiDocument doc, String action, XWikiContext context) {
+    public void notify(XWikiNotificationRule rule, XWikiDocument doc, DocumentAction action, XWikiContext context) {
 
         if (context.getWiki().isReadOnly()) {
             // the server is in read-only mode, forget about the statistics
             return;
         }
         // Unless this is a "view", "save" or "download" action, we are not interested
-        if (!(action.equals("view")||action.equals("save")||action.equals("download")))
+        if (!(action.equals(DocumentAction.VIEW)||action.equals(DocumentAction.SAVE)
+            ||action.equals(DocumentAction.DOWNLOAD)))
             return;
 
         // Let's save in the session the last elements view, saved
         synchronized (this) {
-            if (!action.equals("download")) {
+            if (!action.equals(DocumentAction.DOWNLOAD)) {
                 HttpSession session = context.getRequest().getSession();
-                Collection actions = (Collection) session.getAttribute("recent_" + action);
+                Collection actions = (Collection) session.getAttribute("recent_" + action.toString());
                 if (actions==null) {
                     actions = new CircularFifoBuffer(context.getWiki().getXWikiPreferenceAsInt("recent_visits_size", 20, context));
-                    session.setAttribute("recent_" + action, actions);
+                    session.setAttribute("recent_" + action.toString(), actions);
                 }
                 String element = context.getDatabase() + ":" + doc.getFullName();
                 if (actions.contains(element))
@@ -194,12 +231,12 @@
 
         VisitStats vobject = findVisit(context);
             // We count page views in the sessions only for the "view" action
-            if (action.equals("view"))
+            if (action.equals(DocumentAction.VIEW))
                 vobject.incPageViews();
             // We count "save" and "download" actions separately
-            else if (action.equals("save"))
+            else if (action.equals(DocumentAction.SAVE))
                 vobject.incPageSaves();
-            else if (action.equals("download"))
+            else if (action.equals(DocumentAction.DOWNLOAD))
                 vobject.incDownloads();
 
             vobject.setEndDate(new Date());
@@ -230,7 +267,7 @@
         addPageView("", action, XWikiStats.PERIOD_DAY, store, context, vobject);
 
         // In case of a "view" action we want to store referer info
-        if (action.equals("view")) {
+        if (action.equals(DocumentAction.VIEW)) {
             String referer = getReferer(context);
             if ((referer !=null)&&(!referer.equals(""))) {
                 // Visits of the web
@@ -253,7 +290,7 @@
 
     }
 
-    private void addPageView(String docname, String action, int periodtype, XWikiHibernateStore store, XWikiContext context, VisitStats vobject) {
+    private void addPageView(String docname, DocumentAction action, int periodtype, XWikiHibernateStore store, XWikiContext context, VisitStats vobject) {
         DocumentStats object;
         object = new DocumentStats(docname, action, new Date(), periodtype);
         try {
@@ -264,7 +301,7 @@
 
         // Visits are only for viewing pages
         if (docname.equals("")) {
-         if ((vobject.getPageViews()==1)&&(action.equals("view"))) {
+         if ((vobject.getPageViews()==1)&&(action.equals(DocumentAction.VIEW))) {
             object.incVisits();
          }
         }
Index: src/main/java/com/xpn/xwiki/stats/api/XWikiStatsService.java
===================================================================
--- src/main/java/com/xpn/xwiki/stats/api/XWikiStatsService.java	(revision 3976)
+++ src/main/java/com/xpn/xwiki/stats/api/XWikiStatsService.java	(working copy)
@@ -23,6 +23,7 @@
 
 import com.xpn.xwiki.XWikiContext;
 import com.xpn.xwiki.XWikiException;
+import com.xpn.xwiki.api.DocumentAction;
 import com.xpn.xwiki.notify.XWikiActionNotificationInterface;
 import com.xpn.xwiki.stats.impl.DocumentStats;
 
@@ -32,9 +33,25 @@
 
 public interface XWikiStatsService extends XWikiActionNotificationInterface {
     public void init(XWikiContext context);
+    /**
+     * @deprecated use {@link XWikiStatsService#getDocTotalStats(String, DocumentAction, XWikiContext)} 
+     */
     public DocumentStats getDocTotalStats(String docname, String action, XWikiContext context);
+    public DocumentStats getDocTotalStats(String docname, DocumentAction action, XWikiContext context);
+    /**
+     * @deprecated use {@link XWikiStatsService#getDocMonthStats(String, DocumentAction, Date, XWikiContext)} 
+     */
     public DocumentStats getDocMonthStats(String docname, String action, Date month, XWikiContext context);
+    public DocumentStats getDocMonthStats(String docname, DocumentAction action, Date month, XWikiContext context);
+    /**
+     * @deprecated {@link XWikiStatsService#getDocDayStats(String, DocumentAction, Date, XWikiContext)} 
+     */
     public DocumentStats getDocDayStats(String docname, String action, Date day, XWikiContext context);
+    public DocumentStats getDocDayStats(String docname, DocumentAction action, Date day, XWikiContext context);
     public List getRefMonthStats(String docName, Date month, XWikiContext context) throws XWikiException;
+    /**
+     * @deprecated use {@link XWikiStatsService#getRecentActions(DocumentAction, int, XWikiContext)} 
+     */
     public Collection getRecentActions(String action, int size, XWikiContext context);
+    public Collection getRecentActions(DocumentAction action, int size, XWikiContext context);
 }
Index: src/main/java/com/xpn/xwiki/plugin/zipexplorer/ZipExplorerPlugin.java
===================================================================
--- src/main/java/com/xpn/xwiki/plugin/zipexplorer/ZipExplorerPlugin.java	(revision 3976)
+++ src/main/java/com/xpn/xwiki/plugin/zipexplorer/ZipExplorerPlugin.java	(working copy)
@@ -40,6 +40,7 @@
 import com.xpn.xwiki.api.Api;
 import com.xpn.xwiki.api.Attachment;
 import com.xpn.xwiki.api.Document;
+import com.xpn.xwiki.api.DocumentAction;
 import com.xpn.xwiki.doc.XWikiAttachment;
 import com.xpn.xwiki.objects.classes.ListItem;
 import com.xpn.xwiki.plugin.XWikiDefaultPlugin;
@@ -114,12 +115,12 @@
         // Verify if we should return the original attachment. This will happen if the requested
         // download URL doesn't point to a zip or if the URL doesn't point to a file inside the ZIP.
         if (!isZipFile(attachment.getFilename())
-            || !isValidZipURL(url, context.getAction().trim()))
+            || !isValidZipURL(url, context.getAction()))
         {
             return attachment;
         }
 
-        String filename = getFileLocationFromZipURL(url, context.getAction().trim());
+        String filename = getFileLocationFromZipURL(url, context.getAction());
 
         // Create the new attachment pointing to the file inside the ZIP
         XWikiAttachment newAttachment = new XWikiAttachment();
@@ -257,7 +258,7 @@
 
     /**
      * @param url the URL to parse and from which to extract the relative file location
-     * @param action the XWiki requested action (for example "download", "edit", "view", etc).
+     * @param action the XWiki requested action.
      * @return the relative file location of a file in the ZIP file pointed to by the passed URL.
      *         The ZIP URL must be of the format
      *         <code>http://[...]/zipfile.zip/SomeDirectory/SomeFile.txt</code>.
@@ -268,9 +269,10 @@
      *       manipulation. Once this exists remove this code.
      *       See http://jira.xwiki.org/jira/browse/XWIKI-437
      */
-    protected String getFileLocationFromZipURL(String url, String action)
+    protected String getFileLocationFromZipURL(String url, DocumentAction action)
     {
-        String path = url.substring(url.indexOf(URL_SEPARATOR + action));
+        String actionString = action.toString();
+        String path = url.substring(url.indexOf(URL_SEPARATOR + actionString));
         int pos = 0;
         for (int i = 0; pos > -1 && i < 4; i++) {
             pos = path.indexOf(URL_SEPARATOR, pos + 1);
@@ -305,10 +307,10 @@
 
     /**
      * @param url the ZIP URL to check
-     * @param action the XWiki requested action (for example "download", "edit", "view", etc).
+     * @param action the XWiki requested action.
      * @return true if the ZIP URL points to a file inside the ZIP or false otherwise
      */
-    protected boolean isValidZipURL(String url, String action)
+    protected boolean isValidZipURL(String url, DocumentAction action)
     {
         boolean isValidZipURL = false;
         try {
Index: src/main/java/com/xpn/xwiki/plugin/packaging/DocumentInfo.java
===================================================================
--- src/main/java/com/xpn/xwiki/plugin/packaging/DocumentInfo.java	(revision 3976)
+++ src/main/java/com/xpn/xwiki/plugin/packaging/DocumentInfo.java	(working copy)
@@ -23,6 +23,7 @@
 
 import com.xpn.xwiki.XWikiContext;
 import com.xpn.xwiki.XWikiException;
+import com.xpn.xwiki.api.DocumentAction;
 import com.xpn.xwiki.doc.XWikiDocument;
 import org.apache.commons.logging.Log;
 import org.apache.commons.logging.LogFactory;
@@ -105,7 +106,7 @@
             if (this.doc == null)
                 return installable;
             try {
-                if ((!isAdmin)&&(!context.getWiki().checkAccess("edit", this.doc, context)))
+                if ((!isAdmin)&&(!context.getWiki().checkAccess(DocumentAction.EDIT, this.doc, context)))
                     return installable;
                 XWikiDocument doc1 = context.getWiki().getDocument(doc.getFullName(), context);
                 boolean isNew = doc1.isNew();
Index: src/main/java/com/xpn/xwiki/plugin/packaging/Package.java
===================================================================
--- src/main/java/com/xpn/xwiki/plugin/packaging/Package.java	(revision 3976)
+++ src/main/java/com/xpn/xwiki/plugin/packaging/Package.java	(working copy)
@@ -50,6 +50,7 @@
 import com.xpn.xwiki.XWiki;
 import com.xpn.xwiki.XWikiContext;
 import com.xpn.xwiki.XWikiException;
+import com.xpn.xwiki.api.DocumentAction;
 import com.xpn.xwiki.doc.XWikiDocument;
 import com.xpn.xwiki.objects.classes.BaseClass;
 
@@ -187,7 +188,7 @@
     public boolean add(XWikiDocument doc, int defaultAction, XWikiContext context)
         throws XWikiException
     {
-        if (!context.getWiki().checkAccess("edit", doc, context)) {
+        if (!context.getWiki().checkAccess(DocumentAction.EDIT, doc, context)) {
             return false;
         }
         for (int i = 0; i < files.size(); i++) {
Index: src/main/java/com/xpn/xwiki/plugin/charts/actions/CreateChartAction.java
===================================================================
--- src/main/java/com/xpn/xwiki/plugin/charts/actions/CreateChartAction.java	(revision 3976)
+++ src/main/java/com/xpn/xwiki/plugin/charts/actions/CreateChartAction.java	(working copy)
@@ -22,6 +22,7 @@
 
 import com.xpn.xwiki.XWikiContext;
 import com.xpn.xwiki.XWikiException;
+import com.xpn.xwiki.api.DocumentAction;
 import com.xpn.xwiki.doc.XWikiDocument;
 import com.xpn.xwiki.plugin.charts.RadeoxHelper;
 import com.xpn.xwiki.plugin.charts.exceptions.ParamException;
@@ -55,7 +56,7 @@
         doc.setContent(doc.getContent()+"\n\n"+chartRadeoxMacro);
         context.getWiki().saveDocument(doc, context);
 		try {
-			response.sendRedirect(doc.getURL("view", true, context));
+			response.sendRedirect(doc.getURL(DocumentAction.VIEW, true, context));
 		} catch(IOException ex) {
         	throw new XWikiException(XWikiException.MODULE_XWIKI_PLUGINS,
         			XWikiException.ERROR_XWIKI_UNKNOWN, ex.getMessage(), ex);
Index: src/main/java/com/xpn/xwiki/plugin/charts/ChartingPlugin.java
===================================================================
--- src/main/java/com/xpn/xwiki/plugin/charts/ChartingPlugin.java	(revision 3976)
+++ src/main/java/com/xpn/xwiki/plugin/charts/ChartingPlugin.java	(working copy)
@@ -21,7 +21,9 @@
 package com.xpn.xwiki.plugin.charts;
 
 import com.xpn.xwiki.XWikiContext;
+import com.xpn.xwiki.api.AccessLevel;
 import com.xpn.xwiki.api.Api;
+import com.xpn.xwiki.api.DocumentAction;
 import com.xpn.xwiki.plugin.XWikiDefaultPlugin;
 import com.xpn.xwiki.plugin.XWikiPluginInterface;
 import com.xpn.xwiki.plugin.charts.exceptions.DataSourceException;
@@ -76,7 +78,9 @@
             } catch (Exception e2) {
             	log.error("Could not create charts temporary directory: "+tempDir, e2);
             }
-        };
+        }
+        //create and put this plugin's action in the action map
+        DocumentAction.valueOf("charting", AccessLevel.VIEW);
     }
 
     public String getName() {
@@ -169,7 +173,7 @@
 				params.getInteger(ChartParams.HEIGHT).intValue());
 		
         String imageURL = context.getDoc().getAttachmentURL(
-        		file.getName(), "charting", context);
+        		file.getName(), DocumentAction.valueOf("charting"), context);
 		String pageURL = imageURL;
 		return new ChartImpl(params, imageURL, pageURL);
 	}
Index: src/main/java/com/xpn/xwiki/plugin/graphviz/GraphVizPlugin.java
===================================================================
--- src/main/java/com/xpn/xwiki/plugin/graphviz/GraphVizPlugin.java	(revision 3976)
+++ src/main/java/com/xpn/xwiki/plugin/graphviz/GraphVizPlugin.java	(working copy)
@@ -22,7 +22,9 @@
 package com.xpn.xwiki.plugin.graphviz;
 
 import com.xpn.xwiki.XWikiContext;
+import com.xpn.xwiki.api.AccessLevel;
 import com.xpn.xwiki.api.Api;
+import com.xpn.xwiki.api.DocumentAction;
 import com.xpn.xwiki.plugin.XWikiDefaultPlugin;
 import com.xpn.xwiki.plugin.XWikiPluginInterface;
 import com.xpn.xwiki.web.XWikiResponse;
@@ -91,7 +93,9 @@
                     mLogger.error("Cannot find graphiz neato program at " + neatoPath);
             } catch (Exception e) {}
         }
-
+        
+        //declare the "dot" action with the view access level
+        DocumentAction.valueOf("dot", AccessLevel.VIEW);
     }
 
     public byte[] getDotImage(String content, boolean dot) throws IOException {
@@ -213,6 +217,6 @@
 
     public String getDotImageURL(String content, boolean dot, XWikiContext context) throws IOException {
         String filename = writeDotImage(content, "gif", dot);
-        return context.getDoc().getAttachmentURL(filename, "dot", context);
+        return context.getDoc().getAttachmentURL(filename, DocumentAction.valueOf("dot"), context);
     }
 }
Index: src/main/java/com/xpn/xwiki/plugin/svg/SVGPlugin.java
===================================================================
--- src/main/java/com/xpn/xwiki/plugin/svg/SVGPlugin.java	(revision 3976)
+++ src/main/java/com/xpn/xwiki/plugin/svg/SVGPlugin.java	(working copy)
@@ -22,7 +22,9 @@
 package com.xpn.xwiki.plugin.svg;
 
 import com.xpn.xwiki.XWikiContext;
+import com.xpn.xwiki.api.AccessLevel;
 import com.xpn.xwiki.api.Api;
+import com.xpn.xwiki.api.DocumentAction;
 import com.xpn.xwiki.plugin.XWikiDefaultPlugin;
 import com.xpn.xwiki.plugin.XWikiPluginInterface;
 import com.xpn.xwiki.web.XWikiResponse;
@@ -76,6 +78,9 @@
         } catch (Exception ex) {
             mLogger.warn("Cannot create temporary files", ex);
         }
+        
+        //create the svg action with view access level
+        DocumentAction.valueOf("svg", AccessLevel.VIEW);
     }
 
     public byte[] getSVGImage(String content, int height, int width) throws IOException, SVGConverterException {
@@ -193,6 +198,6 @@
 
     public String getSVGImageURL(String content, int height, int width, XWikiContext context) throws IOException, SVGConverterException {
         String filename = writeSVGImage(content, "png", height, width);
-        return context.getDoc().getAttachmentURL(filename, "svg", context);
+        return context.getDoc().getAttachmentURL(filename, DocumentAction.valueOf("svg"), context);
     }
 }
Index: src/main/java/com/xpn/xwiki/plugin/captcha/CaptchaPlugin.java
===================================================================
--- src/main/java/com/xpn/xwiki/plugin/captcha/CaptchaPlugin.java	(revision 3976)
+++ src/main/java/com/xpn/xwiki/plugin/captcha/CaptchaPlugin.java	(working copy)
@@ -27,6 +27,7 @@
 import com.xpn.xwiki.XWikiContext;
 import com.xpn.xwiki.XWikiException;
 import com.xpn.xwiki.api.Api;
+import com.xpn.xwiki.api.DocumentAction;
 import com.xpn.xwiki.plugin.XWikiDefaultPlugin;
 import com.xpn.xwiki.plugin.XWikiPluginInterface;
 import com.xpn.xwiki.web.XWikiRequest;
@@ -91,7 +92,7 @@
             output.append("<td><img class=\"");
             output.append(classname);
             output.append("\" ");
-            output.append("src=\"" + context.getDoc().getURL("jcaptcha", context) + "\">");
+            output.append("src=\"" + context.getDoc().getURL(DocumentAction.valueOf("jcaptcha"), context) + "\">");
             output.append("</td></tr>");
             output.append("</table>");
         } else if (typecaptcha.equalsIgnoreCase("text")) {
Index: src/main/java/com/xpn/xwiki/plugin/feed/FeedPlugin.java
===================================================================
--- src/main/java/com/xpn/xwiki/plugin/feed/FeedPlugin.java	(revision 3976)
+++ src/main/java/com/xpn/xwiki/plugin/feed/FeedPlugin.java	(working copy)
@@ -34,6 +34,7 @@
 import com.xpn.xwiki.XWikiException;
 import com.xpn.xwiki.web.XWikiEngineContext;
 import com.xpn.xwiki.api.Api;
+import com.xpn.xwiki.api.DocumentAction;
 import com.xpn.xwiki.cache.api.XWikiCache;
 import com.xpn.xwiki.cache.api.XWikiCacheNeedsRefreshException;
 import com.xpn.xwiki.doc.XWikiDocument;
@@ -159,7 +160,8 @@
         {
             outputFeed.setTitle(context.getDoc().getFullName());
             try {
-                outputFeed.setUri(context.getWiki().getURL(context.getDoc().getFullName(), "view", context));
+                outputFeed.setUri(context.getWiki().getURL(context.getDoc().getFullName(),
+                    DocumentAction.VIEW, context));
             } catch (XWikiException e) {
                 e.printStackTrace();
             }
@@ -650,7 +652,7 @@
                 try {
                     Object obj[] = (Object[]) it.next();
                     XWikiDocument doc = context.getWiki().getDocument((String) obj[1], context);
-                    if (context.getWiki().getRightService().checkAccess("view", doc, context))
+                    if (context.getWiki().getRightService().checkAccess(DocumentAction.VIEW, doc, context))
                     {
                         BaseObject bObj = doc.getObject("XWiki.FeedEntryClass", ((Integer)obj[0]).intValue());
                         com.xpn.xwiki.api.Object apiObj = new com.xpn.xwiki.api.Object(bObj, context);
Index: src/main/java/com/xpn/xwiki/plugin/query/SecHibernateQuery.java
===================================================================
--- src/main/java/com/xpn/xwiki/plugin/query/SecHibernateQuery.java	(revision 3976)
+++ src/main/java/com/xpn/xwiki/plugin/query/SecHibernateQuery.java	(working copy)
@@ -31,6 +31,7 @@
 import org.apache.jackrabbit.name.QName;
 
 import com.xpn.xwiki.XWikiException;
+import com.xpn.xwiki.api.AccessLevel;
 import com.xpn.xwiki.doc.XWikiAttachment;
 import com.xpn.xwiki.doc.XWikiDocument;
 import com.xpn.xwiki.objects.BaseObject;
@@ -140,7 +141,7 @@
 				try {
 					boolean r = true;
 					for (int i=0; i<rights.size(); i++) {
-						r &= rightserv.hasAccessLevel((String) rights.get(i), user, (String)element[1], getContext());
+						r &= rightserv.hasAccessLevel((AccessLevel) rights.get(i), user, (String)element[1], getContext());
 						if (!r)
 							break;
 					}
@@ -177,11 +178,15 @@
 		return result;
 	}
 	public List getNeededRight() {
+        //because here's the spot where the query right is used for the first time, let's initialize
+        //it here
+        //TODO: move it in a more appropriate place
+        AccessLevel queryAccessLevel = AccessLevel.valueOf("query", true, true);
 		final List r = new ArrayList(2);
 		if (isViewRight)
-			r.add("view");
+			r.add(AccessLevel.VIEW);
 		if (isQueryRight)
-			r.add("query");
+			r.add(queryAccessLevel);
 		return r;
 	}
 	public boolean isAllowed() {
Index: src/main/java/com/xpn/xwiki/plugin/lucene/SearchResult.java
===================================================================
--- src/main/java/com/xpn/xwiki/plugin/lucene/SearchResult.java	(revision 3976)
+++ src/main/java/com/xpn/xwiki/plugin/lucene/SearchResult.java	(working copy)
@@ -21,6 +21,8 @@
 
 import com.xpn.xwiki.XWikiException;
 import com.xpn.xwiki.api.Document;
+import com.xpn.xwiki.api.DocumentAction;
+
 import org.apache.log4j.Logger;
 import org.apache.commons.logging.Log;
 import org.apache.commons.logging.LogFactory;
@@ -90,7 +92,7 @@
                 .append(name).toString();
             try {
                 document = xwiki.getDocument(fullDocName);
-                url = document.getAttachmentURL(filename, "download");
+                url = document.getAttachmentURL(filename, DocumentAction.DOWNLOAD);
             } catch (XWikiException e) {
                 LOG.error("error retrieving url for attachment " + filename + " of document " +
                     fullDocName);
